From 95d558c50b95729d109aa0135795c1887812ee1d Mon Sep 17 00:00:00 2001
From: Claudio Freire <klaussfreire@gmail.com>
Date: Wed, 14 Mar 2018 19:22:29 -0300
Subject: [PATCH 1/2] Ignore last offset

---
 src/backend/access/nbtree/nbtinsert.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/src/backend/access/nbtree/nbtinsert.c b/src/backend/access/nbtree/nbtinsert.c
index 2525667..ab239c4 100644
--- a/src/backend/access/nbtree/nbtinsert.c
+++ b/src/backend/access/nbtree/nbtinsert.c
@@ -159,8 +159,9 @@ top:
 			!P_INCOMPLETE_SPLIT(lpageop) &&
 			!P_IGNORE(lpageop) &&
 			(PageGetFreeSpace(page) > itemsz) &&
+			PageGetMaxOffsetNumber(page) >= P_FIRSTDATAKEY(lpageop) &&
 			_bt_compare(rel, natts, itup_scankey, page,
-						RelationGetLastOffset(rel)) >= 0)
+						P_FIRSTDATAKEY(lpageop)) > 0)
 		{
 			offset = InvalidOffsetNumber;
 			fastpath = true;
-- 
1.8.4.5

